Generador TOTP (códigos 2FA)

Genera códigos de un solo uso basados en tiempo (TOTP) desde un secreto Base32 con SHA-1/256/512, 6–8 dígitos y cualquier periodo. Cuenta atrás en vivo; verificado (RFC 6238).

La clave que muestra el servicio al activar la 2FA. Se admiten espacios y minúsculas.

Déjalo vacío para usar la hora actual.

TOTP (RFC 6238) calcula HOTP con el contador T = floor(tiempo Unix / periodo). La mayoría de apps usan SHA-1, 6 dígitos y 30 segundos. El reloj del dispositivo debe ser exacto. La clave no sale de tu navegador, pero trátala como una contraseña.

Se ejecuta completamente en tu navegador. Tus datos nunca se suben.

¿Qué es Generador TOTP (2FA)?

Esta herramienta calcula los mismos códigos de 6 a 8 dígitos que muestran las apps de autenticación a partir de una clave secreta Base32. Se actualiza en vivo con una cuenta atrás, muestra también los códigos anterior y siguiente, y puede calcular el código para cualquier tiempo Unix para probar servidores.

Cómo usar Generador TOTP (2FA)

  1. Pega la Clave secreta (Base32) o haz clic en Nueva clave aleatoria.
  2. Ajusta Algoritmo, Dígitos y Periodo según el servicio (normalmente SHA-1, 6, 30).
  3. Consulta el código actual y los segundos restantes.
  4. Opcionalmente, introduce un Tiempo Unix para calcular el código de un momento concreto.

Ejemplo

Entrada
Secret GEZDGNBVGY3TQOJQGEZDGNBVGY3TQOJQ, SHA-1, 8 digits, Unix time 59
Salida
94287082

Vector de prueba del apéndice B del RFC 6238 (el secreto es el ASCII 12345678901234567890 en Base32).

Cuándo usar Generador TOTP (2FA)

Úsalo para probar una implementación de 2FA, recuperar códigos en el ordenador cuando tienes el secreto o entender cómo funciona TOTP. No guardes los secretos de tus cuentas reales en pestañas del navegador; usa una app de autenticación o un gestor de contraseñas.

Cómo funciona Generador TOTP (2FA)

TOTP (RFC 6238) calcula HOTP (RFC 4226) con el contador T = floor(tiempo Unix / periodo): HMAC-SHA-1/256/512 del contador de 8 bytes big-endian con la clave secreta decodificada de Base32, después truncamiento dinámico (desplazamiento = último nibble) y módulo 10^dígitos. El HMAC se calcula con la Web Crypto API. Todos los vectores de prueba del apéndice B del RFC 6238 se reproducen exactamente.

Casos de Uso Comunes

  • Probar el inicio de sesión TOTP en una aplicación web en desarrollo
  • Comprobar el desfase del reloj del servidor comparando códigos
  • Reproducir los vectores de prueba del RFC 6238
  • Generar códigos para una cuenta de prueba en documentación de CI

Nota de Seguridad

Un secreto TOTP es tan sensible como una contraseña: quien lo tenga puede generar tus códigos.

Preguntas Frecuentes

¿Por qué mis códigos no coinciden con los de la app?

Comprueba que el algoritmo, los dígitos y el periodo coinciden y que el reloj de tu ordenador es exacto; una diferencia de 30 segundos cambia el código.

¿Se envía mi secreto a algún sitio?

No. El HMAC se calcula en tu navegador con Web Crypto.

¿Qué alfabeto Base32 se usa?

El del RFC 4648: A–Z y 2–7. Se aceptan e ignoran espacios, guiones, minúsculas y el relleno =.

Explora más categorías